﻿----------------------------------------------------------------------------------
-- Addon:         ProGuide - Guide Handler UI
-- Author:        Claus Gade Pedersen - Satisfyme
-- File:          Slash_Commands.lua
-- Description:   Manage all Pro Guide relates slash commands.
----------------------------------------------------------------------------------
-- Addon version: 21
-- File Revision: 16
-- Last Edit:     2011-09-18T21:23:36Z
-- Last Edit By:  satisfyme
----------------------------------------------------------------------------------

SLASH_PGITEMID1="/itemid"
function SlashCmdList.PGITEMID(msg, editbox)
  local _,link=GetItemInfo(msg)
  if link then
    ChatFrame1:AddMessage(msg .. " has item ID: " .. link:match("item:(%d+):"));
  end
end

SLASH_PGHEART1="/heartloc"
SLASH_PGHEART2="/hloc"
function SlashCmdList.PGHEART(msg, editbox)
  print(GetBindLocation())
end

-- this is for test and will be removed later
SLASH_PGGUIDE1="/proguide"
SLASH_PGGUIDE2="/pg"
function SlashCmdList.PGGUIDE(msg, editbox)
  if msg == "test" then
    print("Num Data: " .. ProGuide:tnum(ProGuide.Data))
    print("Num Guides: " .. ProGuide:tnum(ProGuide.Guides))
    print("Part: " .. ProGuide.db.char.Guides["Tailoring 1-525"].ActivePart .. " - Step: " .. ProGuide.db.char.Guides["Tailoring 1-525"].ActiveStep)
  elseif msg == "elements" then
    ProGuide:PrintContentElements()
  elseif msg == "help" then
    print("===================================")
    print("ProGuide Help")
    print("-----------------------------------")
    print("Use /pg or /proguide + command")
    print("-----------------------------------")
    print("Commandlist:")
    print("test - holds test functions.")
    print("elements - Shows number of elements used.")
    print("help - shows this page.")
    print("===================================")
  else
    print("use /proguide help to get commands")
  end
-- /run ProGuide:LoadGuide(ProGuide.Obj[1], ProGuide.db.char.ObjFrames[1].Guide)
-- /run ProGuide:PrintContentElements()

-- ProGuide:RemoveContent(ProGuide.Obj[1], "all")
end

--[[ Create the parent frame that will contain the inner scroll child,
-- all font strings, and the scroll bar slider.
local fp = FPreviewFrame or CreateFrame("ScrollFrame", "FPreviewFrame")

-- This is a bare-bones frame is used to encapsulate the contents of
-- the scroll frame.  Each scrollframe can have one scroll child.
local fpsc = FPreviewSC or CreateFrame("Frame", "FPreviewSC")

-- Create the slider that will be used to scroll through the results
local fpsb = FPreviewScrollBar or CreateFrame("Slider", "FPreviewScrollBar", fp)

-- Set up internal textures for the scrollbar, background and thumb texture
if not fpsb.bg then
   fpsb.bg = fpsb:CreateTexture(nil, "BACKGROUND")
   fpsb.bg:SetAllPoints(true)
   fpsb.bg:SetTexture(0, 0, 0, 0.5)
end

if not fpsb.thumb then
   fpsb.thumb = fpsb:CreateTexture(nil, "OVERLAY")
   fpsb.thumb:SetTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
   fpsb.thumb:SetSize(25, 25)
   fpsb:SetThumbTexture(fpsb.thumb)
end

local genv = getfenv(0)

-- Collect the names of all possible globally defined fonts
local fonts = {}
for k, v in pairs(genv) do
   if type(v) == "table" and type(v.GetObjectType) == "function" then
      local otype = v:GetObjectType()
      if otype == "Font" then
         table.insert(fonts, k)
      end
   end
end

-- Sort the list alphabetically
table.sort(fonts)

-- Create a table that will contain the font strings themselves
fpsc.fstrings = fpsc.fstrings or {}

-- This changes the padding between font strings vertically
local PADDING = 5

-- Store the max width and overall height of the scroll child
local height = 0
local width = 0

-- Iterate the list of fonts collected
for idx, fname in ipairs(fonts) do
   -- If the font string is not created, do so
   if not fpsc.fstrings[idx] then
      print(idx, fname)
      fpsc.fstrings[idx] = fpsc:CreateFontString("FPreviewFS" .. idx, "OVERLAY")
   end

   -- Set the font string to the correct font object, set the text to be the
   -- name of the font and set the height/width of the font string based on
   -- the size of the resulting 'string'.
   local fs = fpsc.fstrings[idx]
   fs:SetFontObject(genv[fname])
   fs:SetText(fname)
   local fwidth = fs:GetStringWidth()
   local fheight = fs:GetStringHeight()
   fs:SetSize(fwidth, fheight)

   -- Place the font strings in rows starting at the top-left
   if idx == 1 then
      fs:SetPoint("TOPLEFT", 0, 0)
      height = height + fheight
   else
      fs:SetPoint("TOPLEFT", fpsc.fstrings[idx - 1], "BOTTOMLEFT", 0, - PADDING)
      height = height + fheight + PADDING
   end

   -- Update the 'max' width of the frame
   width = (fwidth > width) and fwidth or width
end

-- Set the size of the scroll child
fpsc:SetSize(width, height)

-- Size and place the parent frame, and set the scrollchild to be the
-- frame of font strings we've created
fp:SetSize(width, 400)
fp:SetPoint("CENTER", UIParent, 0, 0)
fp:SetScrollChild(fpsc)
fp:Show()

fpsc:SetSize(width, height)

-- Set up the scrollbar to work properly
local scrollMax = height - 400
fpsb:SetOrientation("VERTICAL");
fpsb:SetSize(16, 400)
fpsb:SetPoint("TOPLEFT", fp, "TOPRIGHT", 0, 0)
fpsb:SetMinMaxValues(0, scrollMax)
fpsb:SetValue(0)
fpsb:SetScript("OnValueChanged", function(self)
      fp:SetVerticalScroll(self:GetValue())
end)

-- Enable mousewheel scrolling
fp:EnableMouseWheel(true)
fp:SetScript("OnMouseWheel", function(self, delta)
      local current = fpsb:GetValue()

      if IsShiftKeyDown() and (delta > 0) then
         fpsb:SetValue(0)
      elseif IsShiftKeyDown() and (delta < 0) then
         fpsb:SetValue(scrollMax)
      elseif (delta < 0) and (current < scrollMax) then
         fpsb:SetValue(current + 20)
      elseif (delta > 0) and (current > 1) then
         fpsb:SetValue(current - 20)
      end
end) ]]